//
// Created by benedikt on 6/11/19.
//

#ifndef UMC_NEW_MIN_MAX_DEGREE_H
#define UMC_NEW_MIN_MAX_DEGREE_H


namespace boost {
  template<class UndirectedGraph>
  typename graph_traits<UndirectedGraph>::degree_size_type min_degree(UndirectedGraph const& g) {
    typedef typename graph_traits<UndirectedGraph>::degree_size_type deg_type;
    deg_type min_degree = std::numeric_limits<deg_type>::max();
    for (auto vd : boost::make_iterator_range(vertices(g))) {
      auto d = out_degree(vd, g);
      if (d < min_degree) {
        min_degree = d;
      }
    }
    return min_degree;
  }

  template<class UndirectedGraph>
  typename graph_traits<UndirectedGraph>::degree_size_type max_degree(UndirectedGraph const& g) {
    typedef typename graph_traits<UndirectedGraph>::degree_size_type deg_type;
    deg_type max_degree = std::numeric_limits<deg_type>::min();
    for (auto vd : boost::make_iterator_range(vertices(g))) {
      auto d = out_degree(vd, g);
      if (d > max_degree) {
        max_degree = d;
      }
    }
    return max_degree;
  }
}

#endif //UMC_NEW_MIN_MAX_DEGREE_H
