//
// Created by benedikt on 4/15/19.
//

#ifndef UMC_NEW_GLOBAL_H
#define UMC_NEW_GLOBAL_H

#include "OutputStatistics.h"
#include <random>

#define _unused(x) ((void)(x))

namespace UMC::Output {
  unsigned long graphs_checked = 0;
  unsigned long unique_fe_cycles_found = 0;
  unsigned long graphs_filtered_triangle_free = 0;
  unsigned long graphs_filtered_cyclically_4_edge_connected = 0;
  unsigned long graphs_filtered_edge_upperbound = 0;
  unsigned long graphs_filtered_large_vertex_cycle = 0;
  unsigned long graphs_filtered_large_vertex_claw = 0;
  unsigned long graphs_filtered_edge_upperbound_no_fixed_edges = 0;
  OutputStatistics global;
  OutputStatistics local;
  double runtime_generation = 0.0;
  double runtime_filter = 0.0;
  double runtime_umc_check = 0.0;
  bool time_limit_reached = false;
}

namespace UMC::internal {
  bool only_graphs = false;
  unsigned long graphs_filter_checked = 0;
  unsigned long max_graphs_filter_checked = (unsigned long) -1;
  double write_probability = 1.0;
  std::uniform_real_distribution<> udis(0.0, 1.0);
  std::random_device rd;  //Will be used to obtain a seed for the random number engine
  std::mt19937 gen(rd()); //Standard mersenne_twister_engine seeded with rd()
  double d2prob = 0.0;
}

#endif //UMC_NEW_GLOBAL_H
